﻿@page "/user"
@inject CRSService DataRetriever
@inject ILocalStorageService LocalStorage 
<style>
    div.collapse {
        display: none;
    }

    div.visible {
        display: block;
    }
</style>
<div class="@login_style">
    <header><h1>Вход в личный кабинет</h1></header>
    <EditForm Model="account" OnValidSubmit="HandleAuthorization">
        <DataAnnotationsValidator />
        <ValidationSummary />
        <div class="red">
            <span></span>
            <h3>Введите имя пользователя</h3>
            <InputText id="login" @bind-Value="account.login" />
            <h3>Введите пароль</h3>
            <InputText id="password" type="password" @bind-Value="account.password" /><br>
            <span></span>
            <button type="submit">Войти</button>
            <button type="button" @onclick="GotoRegistration">Зарегистрироваться</button>
            <button type="reset">Очистить форму</button>
        </div>
    </EditForm>
</div>
<div class="@registration_style">
    <header><h1>Регистрация</h1></header>
    <EditForm Model="account" OnValidSubmit="HandleRegistration">
        <DataAnnotationsValidator />
        <ValidationSummary />
        <div class="red">
            <span></span>
            <h3>Введите имя пользователя</h3>
            <InputText id="login" @bind-Value="account.login" />
            <h3>Введите номер телефона</h3>
            <InputText id="phone" @bind-Value="account.phone" /><br>
            <h3>Введите номер карты</h3>
            <InputText id="cardnum" @bind-Value="account.сardnum" /><br>
            <h3>Введите пароль</h3>
            <InputText id="password1" type="password" @bind-Value="password1" /><br>
            <h3>Введите пароль еще раз</h3>
            <InputText id="password2" type="password" @bind-Value="password2" /><br>
            <span></span>
            <button type="submit" @onclick="GotoRegistration">Зарегистрировать</button>
            <button type="reset">Очистить форму</button>
        </div>
    </EditForm>
</div>
<div class="@cabinet_style">
    <header><h1>Ваши покупки</h1></header>
    <div class="red @personnel_data_style">
        @foreach 
         (
            var acc in DataRetriever.GetDataRows
            (
                new MySqlCommand
                (
                 @"
                  SELECT
                    * 
                 FROM
                    theatre.account
                 WHERE 
                    account.fio='" + account.login + "'")
            ).Result
         )
        {
            <h3>Персональные данные пользователя @acc.Split('\t')[1]</h3>
            <p>
                Номер карты: @acc.Split('\t')[2]<br>
                Телефон: @acc.Split('\t')[3]
            </p>
        }
    </div>
    <Datatable_reader Data="@DataRetriever.GetData(orders).Result" Class="table table-bordered" Style="background-color:rgba(255, 217, 127, 0.69)" />

    <button type="button" @onclick="HandleLogout">Выход</button>
    <button type="button" @onclick="toggle_data">Переключить показ персональных данных</button>
</div>
@code
{   int usr_id { get; set; }
    string password1;
    string password2;
    string login_style => login_toggle ? "visible" : "collapse";
    string registration_style => reg_toggle ? "visible" : "collapse";
    string cabinet_style => cabinet_toggle? "visible" : "collapse";
    string personnel_data_style => data_toggle ? "visible" : "collapse";
    bool login_toggle = true;
    bool reg_toggle = false;
    bool cabinet_toggle = false;
    bool data_toggle = false;
    void toggle_data() => data_toggle = !data_toggle;
    void GotoRegistration()
    {
        login_toggle = !login_toggle;
        reg_toggle = !reg_toggle;
    }
    
    
    void HandleRegistration()
    {
        var reg = new MySqlCommand("INSERT INTO theatre.account (fio,cardnum,phone,password) VALUES (@fio,@cardnum,@phone,@password);");
        if (password1.Equals(password2))
        {
            account.password = password1;
        }
        reg.Parameters.AddWithValue("@fio", account.login);
        reg.Parameters.AddWithValue("@cardnum", account.сardnum);
        reg.Parameters.AddWithValue("@phone", account.phone);
        reg.Parameters.AddWithValue("@password", account.EnycryptPassword());
        DataRetriever.RunCommand(reg);
    }



    async void HandleAuthorization()
    {
        var FindAccount = new MySqlCommand("SELECT * FROM theatre.account WHERE account.fio = @login AND account.password = @password");
        FindAccount.Parameters.AddWithValue("@login", account.login);
        FindAccount.Parameters.AddWithValue("@password", account.EnycryptPassword());
        ObservableCollection<string> Accounts = DataRetriever.GetDataRows(FindAccount).Result;
        if (Accounts.Count == 1)
        {
            Go();
            try
            {
                orders.Parameters.AddWithValue("@login", account.login);
                pdata = DataRetriever.GetDataRowsAsync(orders).Result;
                await LocalStorage.SetItemAsync("IsAuthorized", true);
                await LocalStorage.SetItemAsync("Authorized User ID", Accounts[0].Split('\t')[0]);
            }
            catch (Exception E)
            {
                Console.WriteLine("Ошибки авторизации");
                Console.WriteLine(E.Message);
                Console.WriteLine(E.StackTrace);
            }
        }
    }

    async void HandleLogout()
    {
        Go();
        await LocalStorage.SetItemAsync("IsAuthorized", false);
        await LocalStorage.RemoveItemAsync("Authorized User ID");
    }

    void Go()
    {
        login_toggle = !login_toggle;
        cabinet_toggle = !cabinet_toggle;
    }
private Account account = new Account();
MySqlCommand orders = new MySqlCommand(@"
SELECT
`orders_list`.`showname` as `Спектакль`,
`orders_list`.`date` as `Дата спектакля`,
`orders_list`.`producer` as `Постановщик`,
`orders_list`.`length` as `Продолжительность`,
`orders_list`.`price` as `Цена билета`,
`orders_list`.`fio` as `Заказчик`
FROM
theatre.orders_list
WHERE
orders_list.fio = @login;
");
ObservableCollection<string> pdata;    
}
